<?php
namespace Teknisa\CMP\Modules\V1\Controllers;

use Zeedhi\Framework\DTO;
use Setforms2\Shared\ORM\DateTime;

class Cmp05400 extends \Zeedhi\Framework\Controller\Report {

    protected $qr2Strategy;
    protected $reportMapping = array(
        'Cmp05400' => array(
            'strategy' => 'QR2',
            'parameterMapping'  => array(
                'PRODINICIAL'   => 'P_CDPRODINICOC',
                'PRODFINAL'     => 'P_CDPRODFIMCOC',
                'TODOSPROD'     => 'L_TODOSPROD',
                'TODOSPROD1'    => 'L_TODOSPROD1',
                'NMPRODINICIAL'	=> 'P_NMPRODINI',
                'NMPRODFINAL'   => 'P_NMPRODFIM',
                'DTINI'     	=> 'P_DTINI',
                'DTFIN'       	=> 'P_DTFIM',
                'DTINICIAL'     => 'P_DATAINI',
                'DTFINAL'       => 'P_DATAFIM',
                'FILIAL'        => 'L_CDFILIAL',
                'FILIAL1'       => 'L_CDFILIAL1',
                'COMPRADOR'     => 'L_CDCOMPRADOR',
                'COMPRADOR1'    => 'L_CDCOMPRADOR1',
                'IMPOSTO'       => 'L_CDIMPOSTO',
                'IMPOSTO1'      => 'L_CDIMPOSTO1',
                'REGIAO'        => 'L_CDREGIAO',
                'REGIAO1'       => 'L_CDREGIAO1',
                'AUTOFORNE'     => 'L_AUTOFORNE',
                'FORNECEDOR'    => 'L_CDFORNECED',
                'FORNECEDOR1'   => 'L_CDFORNECED1',
                'GRUPFILI'      => 'L_CDGRUPFILI',
                'GRUPFILI1'     => 'P_CDGRUPFILI',
                'GRUPFILI2'     => 'L_CDGRUPFILI1',
                'GRUPFILI3'     => 'P_CDGRUPFILI1',
                'FILIALPROC'    => 'P_CDFILIPROC',
                'MODO'          => 'P_MODO',
            ),
        ),
		'Cmp05401' => array(
            'strategy' => 'QR2',
            'parameterMapping'  => array(
                'PRODINICIAL'   => 'P_CDPRODINICOC',
                'PRODFINAL'     => 'P_CDPRODFIMCOC',
                'TODOSPROD'     => 'L_TODOSPROD',
                'TODOSPROD1'    => 'L_TODOSPROD1',
                'NMPRODINICIAL'	=> 'P_NMPRODINI',
                'NMPRODFINAL'   => 'P_NMPRODFIM',
                'DTINI'     	=> 'P_DTINI',
                'DTFIN'       	=> 'P_DTFIM',
                'DTINICIAL'     => 'P_DATAINI',
                'DTFINAL'       => 'P_DATAFIM',
                'FILIAL'        => 'L_CDFILIAL',
                'FILIAL1'       => 'L_CDFILIAL1',
                'COMPRADOR'     => 'L_CDCOMPRADOR',
                'COMPRADOR1'    => 'L_CDCOMPRADOR1',
                'IMPOSTO'       => 'L_CDIMPOSTO',
                'IMPOSTO1'      => 'L_CDIMPOSTO1',
                'REGIAO'        => 'L_CDREGIAO',
                'REGIAO1'       => 'L_CDREGIAO1',
                'AUTOFORNE'     => 'L_AUTOFORNE',
                'FORNECEDOR'    => 'L_CDFORNECED',
                'FORNECEDOR1'   => 'L_CDFORNECED1',
                'GRUPFILI'      => 'L_CDGRUPFILI',
                'GRUPFILI1'     => 'P_CDGRUPFILI',
                'GRUPFILI2'     => 'L_CDGRUPFILI1',
                'GRUPFILI3'     => 'P_CDGRUPFILI1',
                'FILIALPROC'    => 'P_CDFILIPROC',
                'MODO'          => 'P_MODO',
            ),
        ),
		'Cmp05402' => array(
            'strategy' => 'QR2',
            'parameterMapping'  => array(
                'PRODINICIAL'   => 'P_CDPRODINICOC',
                'PRODFINAL'     => 'P_CDPRODFIMCOC',
                'TODOSPROD'     => 'L_TODOSPROD',
                'TODOSPROD1'    => 'L_TODOSPROD1',
                'NMPRODINICIAL'	=> 'P_NMPRODINI',
                'NMPRODFINAL'   => 'P_NMPRODFIM',
                'DTINI'     	=> 'P_DTINI',
                'DTFIN'       	=> 'P_DTFIM',
                'DTINICIAL'     => 'P_DATAINI',
                'DTFINAL'       => 'P_DATAFIM',
                'FILIAL'        => 'L_CDFILIAL',
                'FILIAL1'       => 'L_CDFILIAL1',
                'COMPRADOR'     => 'L_CDCOMPRADOR',
                'COMPRADOR1'    => 'L_CDCOMPRADOR1',
                'IMPOSTO'       => 'L_CDIMPOSTO',
                'IMPOSTO1'      => 'L_CDIMPOSTO1',
                'REGIAO'        => 'L_CDREGIAO',
                'REGIAO1'       => 'L_CDREGIAO1',
                'AUTOFORNE'     => 'L_AUTOFORNE',
                'FORNECEDOR'    => 'L_CDFORNECED',
                'FORNECEDOR1'   => 'L_CDFORNECED1',
                'GRUPFILI'      => 'L_CDGRUPFILI',
                'GRUPFILI1'     => 'P_CDGRUPFILI',
                'GRUPFILI2'     => 'L_CDGRUPFILI1',
                'GRUPFILI3'     => 'P_CDGRUPFILI1',
                'FILIALPROC'    => 'P_CDFILIPROC',
                'MODO'          => 'P_MODO',
            ),
        ),
		'Cmp05403' => array(
            'strategy' => 'QR2',
            'parameterMapping'  => array(
                'PRODINICIAL'   => 'P_CDPRODINICOC',
                'PRODFINAL'     => 'P_CDPRODFIMCOC',
                'TODOSPROD'     => 'L_TODOSPROD',
                'TODOSPROD1'    => 'L_TODOSPROD1',
                'NMPRODINICIAL'	=> 'P_NMPRODINI',
                'NMPRODFINAL'   => 'P_NMPRODFIM',
                'DTINI'     	=> 'P_DTINI',
                'DTFIN'       	=> 'P_DTFIM',
                'DTINICIAL'     => 'P_DATAINI',
                'DTFINAL'       => 'P_DATAFIM',
                'FILIAL'        => 'L_CDFILIAL',
                'FILIAL1'       => 'L_CDFILIAL1',
                'COMPRADOR'     => 'L_CDCOMPRADOR',
                'COMPRADOR1'    => 'L_CDCOMPRADOR1',
                'IMPOSTO'       => 'L_CDIMPOSTO',
                'IMPOSTO1'      => 'L_CDIMPOSTO1',
                'REGIAO'        => 'L_CDREGIAO',
                'REGIAO1'       => 'L_CDREGIAO1',
                'AUTOFORNE'     => 'L_AUTOFORNE',
                'FORNECEDOR'    => 'L_CDFORNECED',
                'FORNECEDOR1'   => 'L_CDFORNECED1',
                'GRUPFILI'      => 'L_CDGRUPFILI',
                'GRUPFILI1'     => 'P_CDGRUPFILI',
                'GRUPFILI2'     => 'L_CDGRUPFILI1',
                'GRUPFILI3'     => 'P_CDGRUPFILI1',
                'FILIALPROC'    => 'P_CDFILIPROC',
                'MODO'          => 'P_MODO',
            ),
        ),
		'Cmp05404' => array(
            'strategy' => 'QR2',
            'parameterMapping'  => array(
                'PRODINICIAL'   => 'P_CDPRODINICOC',
                'PRODFINAL'     => 'P_CDPRODFIMCOC',
                'TODOSPROD'     => 'L_TODOSPROD',
                'TODOSPROD1'    => 'L_TODOSPROD1',
                'NMPRODINICIAL'	=> 'P_NMPRODINI',
                'NMPRODFINAL'   => 'P_NMPRODFIM',
                'DTINI'     	=> 'P_DTINI',
                'DTFIN'       	=> 'P_DTFIM',
                'DTINICIAL'     => 'P_DATAINI',
                'DTFINAL'       => 'P_DATAFIM',
                'FILIAL'        => 'L_CDFILIAL',
                'FILIAL1'       => 'L_CDFILIAL1',
                'COMPRADOR'     => 'L_CDCOMPRADOR',
                'COMPRADOR1'    => 'L_CDCOMPRADOR1',
                'IMPOSTO'       => 'L_CDIMPOSTO',
                'IMPOSTO1'      => 'L_CDIMPOSTO1',
                'REGIAO'        => 'L_CDREGIAO',
                'REGIAO1'       => 'L_CDREGIAO1',
                'AUTOFORNE'     => 'L_AUTOFORNE',
                'FORNECEDOR'    => 'L_CDFORNECED',
                'FORNECEDOR1'   => 'L_CDFORNECED1',
                'GRUPFILI'      => 'L_CDGRUPFILI',
                'GRUPFILI1'     => 'P_CDGRUPFILI',
                'GRUPFILI2'     => 'L_CDGRUPFILI1',
                'GRUPFILI3'     => 'P_CDGRUPFILI1',
                'FILIALPROC'    => 'P_CDFILIPROC',
                'MODO'          => 'P_MODO',
            ),
        ),
		'Cmp05405' => array(
            'strategy' => 'QR2',
            'parameterMapping'  => array(
                'PRODINICIAL'   => 'P_CDPRODINICOC',
                'PRODFINAL'     => 'P_CDPRODFIMCOC',
                'TODOSPROD'     => 'L_TODOSPROD',
                'TODOSPROD1'    => 'L_TODOSPROD1',
                'NMPRODINICIAL'	=> 'P_NMPRODINI',
                'NMPRODFINAL'   => 'P_NMPRODFIM',
                'DTINI'     	=> 'P_DTINI',
                'DTFIN'       	=> 'P_DTFIM',
                'DTINICIAL'     => 'P_DATAINI',
                'DTFINAL'       => 'P_DATAFIM',
                'FILIAL'        => 'L_CDFILIAL',
                'FILIAL1'       => 'L_CDFILIAL1',
                'COMPRADOR'     => 'L_CDCOMPRADOR',
                'COMPRADOR1'    => 'L_CDCOMPRADOR1',
                'IMPOSTO'       => 'L_CDIMPOSTO',
                'IMPOSTO1'      => 'L_CDIMPOSTO1',
                'REGIAO'        => 'L_CDREGIAO',
                'REGIAO1'       => 'L_CDREGIAO1',
                'AUTOFORNE'     => 'L_AUTOFORNE',
                'FORNECEDOR'    => 'L_CDFORNECED',
                'FORNECEDOR1'   => 'L_CDFORNECED1',
                'GRUPFILI'      => 'L_CDGRUPFILI',
                'GRUPFILI1'     => 'P_CDGRUPFILI',
                'GRUPFILI2'     => 'L_CDGRUPFILI1',
                'GRUPFILI3'     => 'P_CDGRUPFILI1',
                'FILIALPROC'    => 'P_CDFILIPROC',
                'MODO'          => 'P_MODO',
            ),
        ),
		'Cmp05406' => array(
            'strategy' => 'QR2',
            'parameterMapping'  => array(
                'PRODINICIAL'   => 'P_CDPRODINICOC',
                'PRODFINAL'     => 'P_CDPRODFIMCOC',
                'TODOSPROD'     => 'L_TODOSPROD',
                'TODOSPROD1'    => 'L_TODOSPROD1',
                'NMPRODINICIAL'	=> 'P_NMPRODINI',
                'NMPRODFINAL'   => 'P_NMPRODFIM',
                'DTINI'     	=> 'P_DTINI',
                'DTFIN'       	=> 'P_DTFIM',
                'DTINICIAL'     => 'P_DATAINI',
                'DTFINAL'       => 'P_DATAFIM',
                'FILIAL'        => 'L_CDFILIAL',
                'FILIAL1'       => 'L_CDFILIAL1',
                'COMPRADOR'     => 'L_CDCOMPRADOR',
                'COMPRADOR1'    => 'L_CDCOMPRADOR1',
                'IMPOSTO'       => 'L_CDIMPOSTO',
                'IMPOSTO1'      => 'L_CDIMPOSTO1',
                'REGIAO'        => 'L_CDREGIAO',
                'REGIAO1'       => 'L_CDREGIAO1',
                'AUTOFORNE'     => 'L_AUTOFORNE',
                'FORNECEDOR'    => 'L_CDFORNECED',
                'FORNECEDOR1'   => 'L_CDFORNECED1',
                'GRUPFILI'      => 'L_CDGRUPFILI',
                'GRUPFILI1'     => 'P_CDGRUPFILI',
                'GRUPFILI2'     => 'L_CDGRUPFILI1',
                'GRUPFILI3'     => 'P_CDGRUPFILI1',
                'FILIALPROC'    => 'P_CDFILIPROC',
                'MODO'          => 'P_MODO',
            ),
        ),
		'Cmp05407' => array(
            'strategy' => 'QR2',
            'parameterMapping'  => array(
                'PRODINICIAL'   => 'P_CDPRODINICOC',
                'PRODFINAL'     => 'P_CDPRODFIMCOC',
                'TODOSPROD'     => 'L_TODOSPROD',
                'TODOSPROD1'    => 'L_TODOSPROD1',
                'NMPRODINICIAL'	=> 'P_NMPRODINI',
                'NMPRODFINAL'   => 'P_NMPRODFIM',
                'DTINI'     	=> 'P_DTINI',
                'DTFIN'       	=> 'P_DTFIM',
                'DTINICIAL'     => 'P_DATAINI',
                'DTFINAL'       => 'P_DATAFIM',
                'FILIAL'        => 'L_CDFILIAL',
                'FILIAL1'       => 'L_CDFILIAL1',
                'COMPRADOR'     => 'L_CDCOMPRADOR',
                'COMPRADOR1'    => 'L_CDCOMPRADOR1',
                'IMPOSTO'       => 'L_CDIMPOSTO',
                'IMPOSTO1'      => 'L_CDIMPOSTO1',
                'REGIAO'        => 'L_CDREGIAO',
                'REGIAO1'       => 'L_CDREGIAO1',
                'AUTOFORNE'     => 'L_AUTOFORNE',
                'FORNECEDOR'    => 'L_CDFORNECED',
                'FORNECEDOR1'   => 'L_CDFORNECED1',
                'GRUPFILI'      => 'L_CDGRUPFILI',
                'GRUPFILI1'     => 'P_CDGRUPFILI',
                'GRUPFILI2'     => 'L_CDGRUPFILI1',
                'GRUPFILI3'     => 'P_CDGRUPFILI1',
                'FILIALPROC'    => 'P_CDFILIPROC',
                'MODO'          => 'P_MODO',
            ),
        ),
		'Cmp05408' => array(
            'strategy' => 'QR2',
            'parameterMapping'  => array(
                'PRODINICIAL'   => 'P_CDPRODINICOC',
                'PRODFINAL'     => 'P_CDPRODFIMCOC',
                'TODOSPROD'     => 'L_TODOSPROD',
                'TODOSPROD1'    => 'L_TODOSPROD1',
                'NMPRODINICIAL'	=> 'P_NMPRODINI',
                'NMPRODFINAL'   => 'P_NMPRODFIM',
                'DTINI'     	=> 'P_DTINI',
                'DTFIN'       	=> 'P_DTFIM',
                'DTINICIAL'     => 'P_DATAINI',
                'DTFINAL'       => 'P_DATAFIM',
                'FILIAL'        => 'L_CDFILIAL',
                'FILIAL1'       => 'L_CDFILIAL1',
                'COMPRADOR'     => 'L_CDCOMPRADOR',
                'COMPRADOR1'    => 'L_CDCOMPRADOR1',
                'IMPOSTO'       => 'L_CDIMPOSTO',
                'IMPOSTO1'      => 'L_CDIMPOSTO1',
                'REGIAO'        => 'L_CDREGIAO',
                'REGIAO1'       => 'L_CDREGIAO1',
                'AUTOFORNE'     => 'L_AUTOFORNE',
                'FORNECEDOR'    => 'L_CDFORNECED',
                'FORNECEDOR1'   => 'L_CDFORNECED1',
                'GRUPFILI'      => 'L_CDGRUPFILI',
                'GRUPFILI1'     => 'P_CDGRUPFILI',
                'GRUPFILI2'     => 'L_CDGRUPFILI1',
                'GRUPFILI3'     => 'P_CDGRUPFILI1',
                'FILIALPROC'    => 'P_CDFILIPROC',
                'MODO'          => 'P_MODO',
            ),
        ),
		'Cmp0540A' => array(
            'strategy' => 'QR2',
            'parameterMapping'  => array(
                'PRODINICIAL'   => 'P_CDPRODINICOC',
                'PRODFINAL'     => 'P_CDPRODFIMCOC',
                'TODOSPROD'     => 'L_TODOSPROD',
                'TODOSPROD1'    => 'L_TODOSPROD1',
                'NMPRODINICIAL'	=> 'P_NMPRODINI',
                'NMPRODFINAL'   => 'P_NMPRODFIM',
                'DTINI'     	=> 'P_DTINI',
                'DTFIN'       	=> 'P_DTFIM',
                'DTINICIAL'     => 'P_DATAINI',
                'DTFINAL'       => 'P_DATAFIM',
                'FILIAL'        => 'L_CDFILIAL',
                'FILIAL1'       => 'L_CDFILIAL1',
                'COMPRADOR'     => 'L_CDCOMPRADOR',
                'COMPRADOR1'    => 'L_CDCOMPRADOR1',
                'IMPOSTO'       => 'L_CDIMPOSTO',
                'IMPOSTO1'      => 'L_CDIMPOSTO1',
                'REGIAO'        => 'L_CDREGIAO',
                'REGIAO1'       => 'L_CDREGIAO1',
                'AUTOFORNE'     => 'L_AUTOFORNE',
                'FORNECEDOR'    => 'L_CDFORNECED',
                'FORNECEDOR1'   => 'L_CDFORNECED1',
                'GRUPFILI'      => 'L_CDGRUPFILI',
                'GRUPFILI1'     => 'P_CDGRUPFILI',
                'GRUPFILI2'     => 'L_CDGRUPFILI1',
                'GRUPFILI3'     => 'P_CDGRUPFILI1',
                'FILIALPROC'    => 'P_CDFILIPROC',
                'MODO'          => 'P_MODO',
            ),
        ),
	);

    public function __construct($reportService, $qr2Strategy) {
        
        $this->qr2Strategy      = $qr2Strategy;
        $this->reportService	= $reportService;

    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {

    	$row = $request->getRow();
    	$this->qr2Strategy->setQr2Type($row['QR2TYPE']);

    	$row['FILIAL1'] = $row['FILIAL'];
		$row['COMPRADOR1'] = $row['COMPRADOR'];
		$row['IMPOSTO1'] = $row['IMPOSTO'];
		$row['REGIAO1'] = $row['REGIAO'];
		$row['FORNECEDOR1'] = $row['FORNECEDOR'];
		$row['GRUPFILI1'] = $row['GRUPFILI2'] = $row['GRUPFILI3'] = $row['GRUPFILI'];

    }
}